var LOGFILE_NAME = "devolo-wlan.log";
var l = new Logger(LOGFILE_NAME);

function makeAction(params)
{
	getBaseParams();
    try {
        var h = new HTTP( { 'debug' : 0 },{});
        var code = h.post('http://'+sIP+'/cgi-bin/htmlmgr', '/cgi-bin/htmlmgr', params);
        if (code.status.valueOf() === 200) {
            l.logln(params + ': OK [' + code.status + ']');
        } else {
            l.logln(params + ': FAILED! Server replied: "' + code.status + '"');
            print(code.body);
        }
    } catch (e) {
        l.logln("Error during upload:");
        for (var i in e) {
            print(i + ': ' + e[i]);
        }
    }
}

function registerHLE(name,comment)
{
	Property.setProperty("/usr/events/" + name + "/name",name);
	Property.setProperty("/usr/events/" + name + "/disabled",false);
	Property.setProperty("/usr/events/" + name + "/comment",comment);
	Property.setProperty("/usr/events/" + name + "/script_id",'devolo-wlan');
}

function storeParameter(sParameterString)
{
	try
	{	
		// parameter: config/ip config/monitorPort config/enableMonitor config/password
		var oParameterObject=eval("("+unescape(sParameterString)+")");
		if (oParameterObject.ip!=null)
		{			
			Property.setProperty('config/ip', oParameterObject.ip);
			Property.setFlag('config/ip', 'ARCHIVE', true);
		}
		Property.store();
		var fResult=login();
		var evt = new Event("devolo-wlan-saved",{result:fResult});			
		evt.raise();
	}
	catch(e)
	{
		l.logln("Fehler beim Speichern: " + e);
	}
}

function initOnRunning()
{
	Property.load();
	registerHLE('enable-wlan','Dieses Ereignis schaltet das WLAN ein');
	registerHLE('disable-wlan','Dieses Ereignis schaltet das WLAN ab');
}

function wlanOn()
{
	makeAction("%3Asys%3AWireless.WLANRadio=on&_file=%2Fwgl%2Fmain.wgl&_style=std&_lang=&_dir=wireless&_page=home&_idx");
}

function wlanOff()
{
	makeAction("%3Asys%3AWireless.WLANRadio=off&_file=%2Fwgl%2Fmain.wgl&_style=std&_lang=&_dir=wireless&_page=home&_idx");
}

var sIP=""
var sSession="";
var sPass="";

function getBaseParams()
{
	sIP=Property.getProperty("config/ip");
}
if (raisedEvent.name=="running")
	initOnRunning();
	
if (raisedEvent.name == "devolo-wlan") {
    if (raisedEvent.parameter.actions) {
    	if (raisedEvent.parameter.actions=="test") {
    		
    		var evt = new Event("devolo-wlan-saved",{result:fResult});			
    		evt.raise();
    	}
		if (raisedEvent.parameter.actions=="wlanOff") {
			wlanOff();
		} 
		if (raisedEvent.parameter.actions=="wlanOn") {
			wlanOn();
		}
		if (raisedEvent.parameter.actions=='save') {
			storeParameter(raisedEvent.parameter.value);
		}		
    }
} else 
	if (raisedEvent.name == 'highlevelevent') {
		if (raisedEvent.parameter.name!=null) {
			switch(raisedEvent.parameter.name)
			{
				case 'enable-wlan':
					wlanOn();
					break;
				case 'disable-wlan':
					wlanOff();
					break;
			}
		}				
	}
